Name:           nvidia-prime
Version:        0.3
Release:        0.2
Summary:        Provides GPU (nvidia/intel) selection for NVIDIA optimus laptops
License:        GPLv2
Group:		System/Kernel and hardware
URL:            https://github.com/paltas/FedoraPrime
Source0:        https://github.com/paltas/FedoraPrime/archive/Prime-master.zip
Source1:        xorg.conf.template
Source2:        xinitrc.nvidia
Source3:        fedora-prime-select
Source4:        fedora-prime.service

%define prime_dir %{_sysconfdir}/fedora-prime
BuildRequires:  pkgconfig(systemd)
BuildArch:      noarch

%description
A collection of shell scripts that makes it possible to use the
NVIDIA GPU on a Optimus Laptop. The switching is similar to
the feature provided by the nvidia-prime package in Ubuntu.
However, no such package has been made for other distributions.
This is exactly the functionality this package provide.

%prep
%setup -qn Prime-master

%install
mkdir -p %{buildroot}%{prime_dir}
install -p -m 0755 %{SOURCE1} %{buildroot}%{prime_dir}/
install -p -m 0755 %{SOURCE2} %{buildroot}%{prime_dir}/

mkdir -p %{buildroot}%{_sbindir}
install -p -m 0755 %{SOURCE3} %{buildroot}%{_sbindir}/

mkdir -p %{buildroot}%{_unitdir}
install -p -m 0644 %{SOURCE4} %{buildroot}%{_unitdir}/

%post
systemctl enable fedora-prime.service

%preun
systemctl disable fedora-prime.service

%files
%doc README.md LICENSE
%{prime_dir}/xinitrc.nvidia
%{prime_dir}/xorg.conf.template
%{_sbindir}/fedora-prime-select
%{_unitdir}/fedora-prime.service

